﻿(function () {
    "use strict";

    var _customer = null;
    var _customerIdx = null;

    WinJS.UI.Pages.define("/pages/customerDetails/customerDetails.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            var pageControl = this;
            _customerIdx = options.customerIdx;

            Northwind.Data.getCustomers().then(function (customerList) {
                _customer = customerList.getAt(_customerIdx);

                // Set the page title to the company name.
                element.querySelector(".pagetitle").innerHTML = _customer.companyName;

                // Display the customer details.
                element.querySelector("#companyNameInput").value = _customer.companyName;
                element.querySelector("#contactNameInput").value = _customer.contactName;
                element.querySelector("#contactTitleInput").value = _customer.contactTitle;
                element.querySelector("#contactPhoneInput").value = _customer.phone;
                element.querySelector("#contactFaxInput").value = _customer.fax;
                element.querySelector("#contactAddressInput").value = _customer.address;
                element.querySelector("#contactCityInput").value = _customer.city;
                element.querySelector("#contactRegionInput").value = _customer.region;
                element.querySelector("#contactCountryInput").value = _customer.country;
                element.querySelector("#contactPostalCodeInput").value = _customer.postalCode;

                element.querySelector("#saveCommand").addEventListener("click", pageControl.saveCustomer, false);
                element.querySelector("#ordersCommand").addEventListener("click", pageControl.customerOrders, false);
            });
        },

        saveCustomer: function () {
            var pageStatus = document.querySelector(".pageStatus");
            pageStatus.innerHTML = "Saving...";

            _customer.companyName = document.querySelector("#companyNameInput").value;
            _customer.contactName = document.querySelector("#contactNameInput").value;
            _customer.contactTitle = document.querySelector("#contactTitleInput").value;
            _customer.phone = document.querySelector("#contactPhoneInput").value;
            _customer.fax = document.querySelector("#contactFaxInput").value;

            _customer.region = document.querySelector("#contactRegionInput").value;

            WinJS.Utilities.removeClass(pageStatus, "pageStatusHidden");

            Northwind.Data.saveCustomer(_customer).then(function (response) {
                if (response.saved === true) {
                    pageStatus.innerHTML = "Saved Successfully";
                    WinJS.Utilities.addClass(pageStatus, "pageStatusSuccess");
                    document.querySelector(".pagetitle").textContent = _customer.companyName;
                } else {
                    WinJS.Utilities.addClass(pageStatus, "pageStatusFail");
                    pageStatus.innerHTML = "Error: " + response.message;
                }
            });
        },

        customerOrders: function () {
            WinJS.Navigation.navigate("/pages/customerOrders/customerOrders.html", { customerIdx: _customerIdx });
        }
    });
})();
