﻿// For an introduction to the Page Control template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232511
(function () {
    "use strict";

    var _customer = null;
    var _pageControl = null;
    var _customerIdx = null;

    WinJS.UI.Pages.define("/pages/customerOrders/customerOrders.html", {
        // This function is called whenever a user navigates to this page. It
        // populates the page elements with the app's data.
        ready: function (element, options) {
            _pageControl = this;
            _customerIdx = options.customerIdx;

            Northwind.Data.getCustomers().then(function (customerList) {
                _customer = customerList.getAt(_customerIdx);
                _customer.getOrders().then(function (orders) {
                    var data = [];
                    var categories = [];

                    orders.forEach(function (order) {
                        data.push(order.SubTotal);
                        categories.push(order.OrderID);
                    });

                    var columnSeries = new Telerik.UI.Chart.ColumnSeries();
                    columnSeries.data = data;

                    var ordersChart = element.querySelector("#ordersChart").winControl;
                    ordersChart.series.push(columnSeries);
                    ordersChart.valueAxis.labels.format = "{0:C}";
                    ordersChart.categoryAxis.categories = categories;
                    ordersChart.categoryAxis.labels.format = "Order # {0}";

                    ordersChart.addEventListener("seriesclick", _pageControl.ordersChartSeriesClick, false);
                    ordersChart.refresh();
                });
            });
        },

        ordersChartSeriesClick: function (e) {
            _customer.getOrders().then(function (orders) {
                _pageControl.element.querySelector(".customerOrders .orderFields").removeClass("orderFieldsHidden");

                var order = JSON.find({ data: orders, attr: "OrderID", value: e.category });

                _pageControl.element.querySelector("#orderIdValue").innerHTML = order.OrderID;

                var orderDate = new Date(order.OrderDate);
                _pageControl.element.querySelector("#orderDateValue").innerHTML = (orderDate.getMonth() + 1) + "/" + orderDate.getDate() + "/" + orderDate.getFullYear();

                _pageControl.element.querySelector("#shipNameValue").innerHTML = order.ShipName;

                var shippedDate = new Date(order.ShippedDate);
                _pageControl.element.querySelector("#shippedDateValue").innerHTML = (shippedDate.getMonth() + 1) + "/" + shippedDate.getDate() + "/" + shippedDate.getFullYear();
            });
        }
    });
})();
